function defineVar()
	deltaspeed = 38
	accelSpeed = 0.046875
	decelSpeed = 0.5
	frictSpeed = accelSpeed
	topSpeed = 6
	print("Defined constants")
	x = 5
	y = 200
	xSpeed = 0
	ySpeed = 0
	grndSpeed = 0
	grndAng = 0
	--widthRadi
	--heightRadi
	minimum = 0
	sign = 0
	print("Defined Variables")
end

function deceleratePhys()
	--[[if grndSpeed > 0 then
		grndSpeed = grndSpeed - decelSpeed * dt * deltaspeed
	elseif grndSpeed < 0 then
		grndSpeed = grndSpeed + decelSpeed * dt * deltaspeed
	end--]]

	if math.abs(grndSpeed) > 0.1 then
		minimum = 0.1
	else
		minimum = math.abs(grndSpeed)
	end
	if grndSpeed > 0 then
		sign = 1
	elseif grndSpeed < 0 then
		sign = -1
	elseif grndSpeed == 0 then
		sign = 0
	end
end

function love.load()
	defineVar()
	sonicSprite = love.graphics.newImage("sonic.png")
	print("Loaded Sonic sprite ", sonicSprite:getWidth(), "x", sonicSprite:getHeight(), "px")
end

function love.update(dt)
	x = x + grndSpeed * dt * deltaspeed

	if not (love.keyboard.isDown("right")) or  (love.keyboard.isDown("left")) then
		deceleratePhys()
		grndSpeed = grndSpeed - (minimum * sign) * dt * deltaspeed
	end
	--if not (love.keyboard.isDown("left")) then
	--	deceleratePhys()
	--	grndSpeed = grndSpeed - (minimum * sign) * dt * deltaspeed
	--end

	if love.keyboard.isDown("left") then --moving left?
		if grndSpeed > 0 then --if moving right still,
			grndSpeed = grndSpeed - decelSpeed --decelerate
			if grndSpeed <= 0 then
				grndSpeed = -0.5 --deceleration quirk
			end
		elseif grndSpeed > -topSpeed then --if actually moving left,
			grndSpeed = grndSpeed - accelSpeed --accelerate
			if grndSpeed <= -topSpeed then
				grndSpeed = -topSpeed --stay at the top speed
			end
		end
	end

	if love.keyboard.isDown("right") then --moving right?
		if grndSpeed < 0 then --still moving left?
			grndSpeed = grndSpeed + decelSpeed --decelerate
			if grndSpeed >= 0 then
				grndSpeed = 0.5 --deceleration quirk
			end
		elseif grndSpeed < topSpeed then --if finally moving right,
			grndSpeed = grndSpeed + accelSpeed --accelerate
			if grndSpeed >= topSpeed then
				grndSpeed = topSpeed --stay at top speed
			end
		end
	end
end

function love.draw()
	love.graphics.print(grndSpeed, 400, 300)
	love.graphics.rectangle("line", x, y, sonicSprite:getWidth(), sonicSprite:getHeight())
	love.graphics.draw(sonicSprite, x, y, 0, 1, 1)
end

--[[

example momentum code from Sonic Retro

if (the player is pressing left)
{
    if (Ground Speed > 0) //if moving to the right
    {
        Ground Speed -= deceleration_speed;  //decelerate
        if (Ground Speed <= 0)
            Ground Speed = -0.5;  //emulate deceleration quirk
    }
    else if (Ground Speed > -top_speed) //if moving to the left
    {
        Ground Speed -= acceleration_speed;  //accelerate
        if (Ground Speed <= -top_speed)
            Ground Speed = -top_speed; //impose top speed limit
    }
}

if (the player is pressing right)
{
    if (Ground Speed < 0) //if moving to the left
    {
        Ground Speed += deceleration_speed; //decelerate
        if (Ground Speed >= 0)
            Ground Speed = 0.5; //emulate deceleration quirk
    }
    else if (Ground Speed < top_speed) //if moving to the right
    {
        Ground Speed += acceleration_speed; //accelerate
        if (Ground Speed >= top_speed)
            Ground Speed = top_speed; //impose top speed limit
    }
}

if (the player is not pressing left or right)
    Ground Speed -= minimum(absolute(Ground Speed), friction_speed) * sign(Ground Speed); //decelerate
 --]]